#include <dbus/dbus-glib.h>
#include <stdlib.h>
#include <limits.h>

#include "input_daemon_server_obj.h"
#include "input_daemon_server_marshall.h"

extern const DBusGObjectInfo dbus_glib_input_daemon_object_info;
DBusGObjectInfo dbus_glib_input_daemon_object_info_modified;

G_DEFINE_TYPE (InputDaemonObject, input_daemon_object, G_TYPE_OBJECT);

enum {
  PROP_0,
  PROP_COM_CITRIX_XENCLIENT_INPUT_NUMLOCK_RESTORE_ON_SWITCH,

  N_PROPERTIES
};

static GParamSpec *obj_properties[N_PROPERTIES] = { NULL, };

static void
handle_set_property(GObject *obj, guint propid, const GValue *value, GParamSpec *spec)
{
    InputDaemonObject *self = INPUT_DAEMON_OBJECT (obj);
    (void) self;
    switch (propid) {
    case PROP_COM_CITRIX_XENCLIENT_INPUT_NUMLOCK_RESTORE_ON_SWITCH: { GError *err = NULL; gboolean v = (gboolean) g_value_get_boolean(value); input_daemon_property_set_numlock_restore_on_switch (self, v, &err); break; }

    }
}

static void
handle_get_property(GObject *obj, guint propid, GValue *value, GParamSpec *spec)
{
    InputDaemonObject *self = INPUT_DAEMON_OBJECT (obj);
    (void) self;
    switch (propid) {
    case PROP_COM_CITRIX_XENCLIENT_INPUT_NUMLOCK_RESTORE_ON_SWITCH: { GError *err = NULL; gboolean v; input_daemon_property_get_numlock_restore_on_switch (self, &v, &err); g_value_set_boolean(value, v); ; break; }

    }
}

static void input_daemon_object_init (InputDaemonObject *obj)
{
}

static void input_daemon_object_class_init (InputDaemonObjectClass *klass)
{
    GObjectClass *gc = G_OBJECT_CLASS(klass);
    obj_properties[PROP_COM_CITRIX_XENCLIENT_INPUT_NUMLOCK_RESTORE_ON_SWITCH] = g_param_spec_boolean ("numlock-restore-on-switch", "", "", FALSE, G_PARAM_READWRITE);

    gc->set_property = handle_set_property;
    gc->get_property = handle_get_property;
    if (N_PROPERTIES > 1)
      g_object_class_install_properties(gc, N_PROPERTIES, obj_properties);
}

InputDaemonObject *input_daemon_create_glib_obj()
{
    dbus_glib_input_daemon_object_info_modified = dbus_glib_input_daemon_object_info;
    dbus_glib_input_daemon_object_info_modified.exported_signals = "\0";
    dbus_g_object_type_install_info(INPUT_DAEMON_TYPE_OBJECT, &dbus_glib_input_daemon_object_info_modified);
    return g_object_new(INPUT_DAEMON_TYPE_OBJECT, NULL);
}

InputDaemonObject *input_daemon_export_dbus(DBusGConnection *conn, const char *path)
{
    InputDaemonObject *obj = input_daemon_create_glib_obj();
    if (!obj) {
        return NULL;
    }
    dbus_g_connection_register_g_object(conn, path, G_OBJECT(obj));
    return obj;
}
